REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
:: OVERVIEW:
::   
:: Note this exact same script is included as the install.bat for
:: install proxy and uninstall.bat for the uninstall proxy.
::
:: USAGE  script <parent dir for FunctionalTester> ["INSTALL" | "UNINSTALL"]
:: 
:: AUTHOR:  Christopher Maguire
::   
:: DATE			COMMENT
:: 2005.10.03	Initial version of script.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


SET log=C:\temp\install.log
SET DEBUG_OUTPUT=0

@ECHO ON
@CALL :LogHeader Start %0
@CALL :SetGlobals %0 %1 %2


@if %ACTION% == "INSTALL" (
	rd /s /q %backup%
	mkdir %backup%
) else (
	cd %1\..
)
@CALL :Main
@if %ACTION% == "UNINSTALL" (
	rd /s /q %backup%
)
@CALL :LogHeader End %0
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: This script is copied to the uninstall proxy's uninstall.bat.
:: When run as uninstall.bat, it is NOT run from the uninstall proxy.
:: To determine if we're being run as install.bat or uninstall.bat we look where we are.
:: If we're uninstalling, 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetGlobals
	SET ACTION=%3
	SET PROD_INSTALL=%2
    SET PROD_INSTALL_NO_QUOTES=%~2
	SET RFTPlugins=%PROD_INSTALL%\FunctionalTester\eclipse\plugins
	SET WSW=%RFTPlugins%\com.rational.test.ft.wswplugin_6.1.0
	SET SIEBEL_DIR=%PROD_INSTALL%\FunctionalTester\Siebel
	SET ERR_CODE=0
	SET result=""
	SET msdnhelpfolder=%PROD_INSTALL%\FunctionalTester\MSDNHelp
	SET backup=%PROD_INSTALL%\FunctionalTester\eclipse\plugins\backup\rft61_fixpack\updater.rft_specific.win32.install
	SET VSNET_DIR=%PROD_INSTALL%\FunctionalTester\vsnet
	SET VSNET_DIR_NO_QUOTES=%PROD_INSTALL_NO_QUOTES%\FunctionalTester\vsnet
	@GOTO :EOF

:Main
	CALL :CheckForDotNetFramework
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GacWithPolicyFile %WSW% rtxftnet.dll policy.6.1.rtxftnet.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToVSNet RftVsNet.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToVSNet  rtclearcaseif.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CallRegsrv %VSNET_DIR% Rftvs.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CallRegsrv %VSNET_DIR% Rftvs8.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CallRegsrv %VSNET_DIR% RftDPEdit.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CallRegsrv %VSNET_DIR% RftDPEdit8.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	SET VSNET_2003_Present=0
	CALL :RunDevEnv 7.1 2003
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	SET VSNET_2005_Present=0
	CALL :RunDevEnv 8.0 Whidbey
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :MSDNHelp
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :SiebelMSDNHelp %SIEBEL_DIR%
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CorrectConfigLocation
	CALL :CleanupRtClearCaseIfDLL
	CALL :InstallSiebel
	@GOTO :EOF

:LogHeader
	@echo "---------------- %1 %2 -----------------"
	@Date /T
	@Time /T
	@echo "Current Directory:"
	cd
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check For DotNet Frame Work 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForDotNetFramework
	@SET regasm1_1=%windir%\Microsoft.NET\Framework\v1.1.4322\regasm.exe
	@SET regasm2_0=%windir%\Microsoft.NET\Framework\v2.0.50727\regasm.exe

	@CALL :CheckFileExistance %regasm2_0% QUIET
	@IF %ERR_CODE%==0 (
		@SET regasm=%regasm2_0%
		@echo "Found .Net Framework 2.0"
		@GOTO :EOF
	)

	@CALL :CheckFileExistance %regasm1_1% QUIET
	@IF %ERR_CODE%==0 (
		@SET regasm=%regasm1_1%
		@echo "Found .Net Framework 1.1"
		@GOTO :EOF
	)
	@echo "Could not find .Net Framework 2.0: %regasm2_0%"
	@echo "Could not find .Net Framework 1.1: %regasm1_1%"
	@echo "No .Net Framework found"
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Run GAC Utility with Policy file
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GacWithPolicyFile
	@SET	ERR_CODE=0
	CALL :CheckFileExistance %1\%2
	@IF %ERR_CODE%==1 GOTO :EOF
	CALL :CheckFileExistance %1\%3
	@IF %ERR_CODE%==1 GOTO :EOF

	gacutility.exe -a %1\%2 -p %1\%3 -o
	@IF %ERRORLEVEL% == 0 ( 
		@echo "GACUtility.exe succeeded"
		@GOTO :EOF
	) else (
		SET ERR_CODE=1
		@echo "GACUtility.exe Error"
	)
	@GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Clean up rtClearCase
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CleanupRtClearCaseIfDLL
	%regasm% /unregister PrivateAssemblies\old\rtclearcaseif.dll"
        @GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   MSDN Help
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:MSDNHelp 
	PUSHD %PROD_INSTALL%\FunctionalTester\MSDNHelp
	call installhelp.bat
	POPD
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Siebel MSDN Help
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SiebelMSDNHelp 
	PUSHD %1\Help\msdn
	call installhelpsiebel.bat
	POPD
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Install Siebel
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallSiebel
	PUSHD %PROD_INSTALL%\FunctionalTester\Siebel
	installSiebel.bat %PROD_INSTALL%
	POPD
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Set Environment Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetEnv
	@set value=%1
	@set data=%2
	@set ENV_KEY="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment" 
	rreg.exe add %ENV_KEY% /v %value% /t REG_SZ /d %data%
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Un-Set Environment Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:UnSetEnv
	@set value=%1
    @echo Trying to remove environment variable %1
	@set ENV_KEY="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment" 
	rreg.exe delete %ENV_KEY% /v %value%
    @if errorlevel 1 (
		@echo You can ignore the above error.  It is due to the environment variable not being set.
		@GOTO :EOF
	)
	@GOTO :EOF

:ComRationalTestFtWelcome
	@if %ACTION% == "INSTALL" (
		@set from=%PROD_INSTALL%\FunctionalTester\eclipse\plugins\com.rational.test.ft.welcome_6.1.0
		@set to=%backup%
	) else (
		@set from=%backup%\com.rational.test.ft.welcome_6.1.0
		@set to=%PROD_INSTALL%\FunctionalTester\eclipse\plugins
	)
	move /Y %from% %to%
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Call Regsrv
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CallRegsrv
	set folder=%1
	set dll=%2
	CALL :CheckFileExistance %folder%\%dll%
	@if not %ERR_CODE% == 0 (
		@GOTO :EOF
	)
	regsvr32.exe /s /i %folder%\%dll%
	@if %ACTION% == "UNINSTALL" (
		@SET	ERR_CODE=0
	)
	@GOTO :EOF
	
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Copy to VS Net
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CopyToVSNet
	SET newDllLocation=%VSNET_DIR_NO_QUOTES%\PrivateAssemblies
	SET dll=%1
	@CALL :CheckFileExistance CopyToVSNet.exe
	if not %ERR_CODE% == 0 (
		GOTO :EOF
	)
	if %ACTION% == "INSTALL" (
		REM Create backup of %dll%
		CopyToVSNet.exe %backup%\%dll% -from
		CALL :CheckFileExistance "%newDllLocation%\%dll%"
		if %ERR_CODE% == 0 (
			if %dll% == RftVsNet.dll (
				regedit /s "%newDllLocation%\RftVsNet.reg"
			)
			CopyToVSNet.exe "%newDllLocation%\%dll%"
			CopyToVSNet.exe "%newDllLocation%\%dll%" -vs8
		)
	) else (
		CALL :CheckFileExistance %backup%\%dll%
		@if %ERR_CODE% == 0 (
			%regasm% %backup%\%dll%
			CopyToVSNet.exe %backup%\%dll%
		)
		@SET ERR_CODE=0
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Run DevEnv
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:RunDevEnv
	@set ver=%1
	@set product=%2
    @echo Trying to run devenv /setup for VS .Net %product%
	@set KEY=HKLM\SOFTWARE\Microsoft\VisualStudio\%ver%
	@set VALUE=InstallDir
    @set REG_QUERY=rreg.exe query %KEY%
    @set errorlevel=
    @%REG_QUERY% /v %VALUE%
    @if errorlevel 1 (
		@echo Unable to locate value %VALUE% for key %KEY%
		@GOTO :EOF
	)
    @set dir=
    @for /f "tokens=2*" %%i in ('%REG_QUERY% /v %VALUE%') do @set dir=%%j
    @if "%dir%" == "" (
		@echo No data for value %VALUE% for key %KEY%
		@GOTO :EOF
	)
	@CALL :CheckFileExistance "%dir%devenv.exe"
	@if not %ERR_CODE% == 0 (
		@GOTO :EOF
	)
	if %ver% == 7.1 (
		SET VSNET_2003_Present=1
	)
	if %ver% == 8.0 (
		SET VSNET_2005_Present=1
	)
    @set cmd="%dir%devenv.exe" /setup
    %cmd%
    @if errorlevel 1 (
		@echo Error returned running %cmd%
	) else (
		@echo SUCCESS running devenv /setup for VS .Net %product%!
	)
    @GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Config files should only be in wsw plugin's top folder if VS Net 2005 is installed
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CorrectConfigLocation
    pushd ..\eclipse\plugins\com.rational.test.ft.wswplugin_6.1.0
    @IF not EXIST configs (
        mkdir configs
		copy /Y rational_ft.exe.config  configs\rational_ft.exe.config
		copy /Y rational_ftw.exe.config configs\rational_ftw.exe.config
    )
	if %VSNET_2005_Present% == 0 (
		@ECHO --- VS Net 2005 NOT installed.
		@ECHO --- Hiding config files if necessary...
		CALL :DelIfFromExists rational_ft.exe.config
		CALL :DelIfFromExists rational_ftw.exe.config
		@ECHO --- Done hiding config files.
	) else (
		@ECHO --- VS Net 2005 installed.
		@ECHO --- Unhiding config files if necessary...
		copy /Y configs\rational_ft.exe.config  rational_ft.exe.config
		copy /Y configs\rational_ftw.exe.config rational_ftw.exe.config
		@ECHO --- Done unhiding config files.
	)
    popd
	@GOTO :EOF

:DelIfFromExists
	@SET from=%1
	if EXIST %from% (
		del /Q /F %from%
	) else (
		@ECHO No need to hide %from%
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	SET ERR_CODE=0
	@IF not EXIST %1 (
		SET ERR_CODE=1
		IF "%2" == "QUIET" GOTO :EOF
		echo ERROR:  Could not find %1
	)
	GOTO :EOF 

:DEBUG
	@if %DEBUG_OUTPUT% == 1 (
		@ECHO %1 >> %LOG%
	)
	@GOTO :EOF

:EXIT_SUCCESS
	e@cho "-------------------------  Install Status --------------------------- "
	e@cho "%0 completed successfully."
	@GOTO	:LAST

:EXIT_WARNING
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 Completed with Warning(s)"
	@GOTO	:LAST


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EXIT_ERROR
:: We never want to exit with non-0 error status.  Doing so would
:: abort the entire installation.  Not what we want.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:EXIT_ERROR
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 failed  with Error : %result%"
	EXIT	0

:LAST
	@echo "--------------------------------------------------------------------- "
